/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package com.rjconsultores.ventaboletos.web.gui.controladores.catalogos;

import java.util.HashMap;
import java.util.List;
import java.util.Map;

import org.apache.commons.lang.StringUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.context.annotation.Scope;
import org.springframework.stereotype.Controller;
import org.zkoss.util.resource.Labels;
import org.zkoss.zhtml.Messagebox;
import org.zkoss.zk.ui.Component;
import org.zkoss.zk.ui.event.Event;
import org.zkoss.zk.ui.event.EventListener;
import org.zkoss.zul.Combobox;
import org.zkoss.zul.Comboitem;
import org.zkoss.zul.Paging;
import org.zkoss.zul.Textbox;

import com.rjconsultores.ventaboletos.entidad.Empresa;
import com.rjconsultores.ventaboletos.entidad.EmpresaTrocoSimples;
import com.rjconsultores.ventaboletos.utilerias.UsuarioLogado;
import com.rjconsultores.ventaboletos.web.utilerias.MyGenericForwardComposer;
import com.rjconsultores.ventaboletos.web.utilerias.MyListbox;
import com.rjconsultores.ventaboletos.web.utilerias.paginacion.HibernateSearchObject;
import com.rjconsultores.ventaboletos.web.utilerias.paginacion.PagedListWrapper;
import com.rjconsultores.ventaboletos.web.utilerias.render.RenderEmpresaTrocoSimples;

@Controller("busquedaEmpresaTrocoSimples")
@Scope("prototype")
public class BusquedaEmpresaTrocoSimplesController extends MyGenericForwardComposer {

	private static final long serialVersionUID = 1L;
	@Autowired
	private transient PagedListWrapper<EmpresaTrocoSimples> plwEmpresaTrocoSimples;

	private MyListbox empresaTrocoSimplesList;
	private Paging pagingEmpresaTrocoSimples;
	private Textbox txtCnpj;
	private Combobox cmbEmpresa;
	
	private List<Empresa> lsEmpresas;
	
	public Combobox getCmbEmpresa() {
		return cmbEmpresa;
	}

	public void setCmbEmpresa(Combobox cmbEmpresa) {
		this.cmbEmpresa = cmbEmpresa;
	}

	public Paging getPagingEmpresaTrocoSimples() {
		return pagingEmpresaTrocoSimples;
	}

	public void setPagingEmpresaTrocoSimples(Paging pagingEmpresaTrocoSimples) {
		this.pagingEmpresaTrocoSimples = pagingEmpresaTrocoSimples;
	}

	public MyListbox getEmpresaTrocoSimplesList() {
		return empresaTrocoSimplesList;
	}

	public void setEmpresaTrocoSimplesList(MyListbox empresaTrocoSimplesList) {
		this.empresaTrocoSimplesList = empresaTrocoSimplesList;
	}

	public PagedListWrapper<EmpresaTrocoSimples> getPlwEmpresaTrocoSimples() {
		return plwEmpresaTrocoSimples;
	}

	public void setPlwEmpresaTrocoSimples(PagedListWrapper<EmpresaTrocoSimples> plwEmpresaTrocoSimples) {
		this.plwEmpresaTrocoSimples = plwEmpresaTrocoSimples;
	}

	public void onClick$btnPesquisa(Event ev) throws InterruptedException {
		refreshLista();
	}

	public void onClick$btnRefresh(Event ev) {
		refreshLista();
	}

	public void onClick$btnNovo(Event ev) {
		editar(new EmpresaTrocoSimples());
	}
	
	public List<Empresa> getLsEmpresas() {
		return lsEmpresas;
	}

	public void setLsEmpresas(List<Empresa> lsEmpresas) {
		this.lsEmpresas = lsEmpresas;
	}


	@Override
	public void doAfterCompose(Component comp) throws Exception {
		super.doAfterCompose(comp);

		lsEmpresas = UsuarioLogado.getUsuarioLogado().getEmpresa();

		
		empresaTrocoSimplesList.setItemRenderer(new RenderEmpresaTrocoSimples());
		empresaTrocoSimplesList.addEventListener("onDoubleClick", new EventListener() {

			@Override
			public void onEvent(Event event) throws Exception {
				EmpresaTrocoSimples e= (EmpresaTrocoSimples) empresaTrocoSimplesList.getSelected();
				editar(e);
			}
		});

		refreshLista();

	}

	@SuppressWarnings({ "rawtypes", "unchecked" })
	private void editar(EmpresaTrocoSimples e) {
		if (e == null) {
			return;
		}

		Map args = new HashMap();
		args.put("empresaTrocoSimples", e);
		args.put("busquedaEmpresaTrocoSimples", this);

		openWindow("/gui/esquema_operacional/editarEmpresaTrocoSimples.zul",
				Labels.getLabel("editarPuntoVentaController.window.title"), args, MODAL);
	}

	public void refreshLista() {
		HibernateSearchObject<EmpresaTrocoSimples> empresaTrocoSimplesBusqueda =
				new HibernateSearchObject<EmpresaTrocoSimples>(EmpresaTrocoSimples.class, pagingEmpresaTrocoSimples.getPageSize());


		Comboitem itemEmpresa = cmbEmpresa.getSelectedItem();

		if (itemEmpresa != null) {
			Empresa empresa = (Empresa) itemEmpresa.getValue();
			empresaTrocoSimplesBusqueda.addFilterEqual("empresa", empresa);
		}

		if (StringUtils.isNotBlank(txtCnpj.getText())) {
			empresaTrocoSimplesBusqueda.addFilterLike("cnpj", txtCnpj.getText().trim().concat("%"));
		}

		empresaTrocoSimplesBusqueda.addFilterEqual("activo", Boolean.TRUE);
		empresaTrocoSimplesBusqueda.addSortAsc("empresa.nombempresa");

		plwEmpresaTrocoSimples.init(empresaTrocoSimplesBusqueda, empresaTrocoSimplesList, pagingEmpresaTrocoSimples);

		if (empresaTrocoSimplesList.getData().length == 0) {
			try {
				Messagebox.show(Labels.getLabel("MSG.ningunRegistro"),
						Labels.getLabel("editarEmpresaTrocoSimples.window.title"),
						Messagebox.OK, Messagebox.INFORMATION);
			}
			catch (InterruptedException ex) {
			}
		}
	}
}
